package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityClamp;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.List;
import java.util.Objects;
import java.util.function.Consumer;
import java.util.function.Predicate;
import javax.annotation.Nullable;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.random.WeightedEntry;
import net.minecraft.util.random.WeightedRandom;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.level.storage.loot.Serializer;
import net.minecraft.world.level.storage.loot.entries.LootPoolEntryType;
import net.minecraft.world.level.storage.loot.entries.LootPoolSingletonContainer;
import net.minecraft.world.level.storage.loot.functions.LootItemFunction;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;

public class GemLootPoolEntry extends LootPoolSingletonContainer {
  public static final Serializer SERIALIZER = new Serializer();
  
  public static final LootPoolEntryType TYPE = new LootPoolEntryType((Serializer)SERIALIZER);
  
  @Nullable
  private final RarityClamp.Simple rarityLimit;
  
  private final List<DynamicHolder<Gem>> gems;
  
  public GemLootPoolEntry(@Nullable RarityClamp.Simple rarityLimit, List<ResourceLocation> gems, int weight, int quality, LootItemCondition[] conditions, LootItemFunction[] functions) {
    super(weight, quality, conditions, functions);
    this.rarityLimit = rarityLimit;
    Objects.requireNonNull(GemRegistry.INSTANCE);
    this.gems = gems.stream().map(GemRegistry.INSTANCE::holder).toList();
  }
  
  protected void m_6948_(Consumer<ItemStack> list, LootContext ctx) {
    Gem gem;
    if (!this.gems.isEmpty()) {
      List<WeightedEntry.Wrapper<Gem>> resolved = this.gems.stream().map(this::unwrap).filter(Objects::nonNull).map(e -> e.wrap(ctx.m_78945_())).toList();
      gem = (Gem)((WeightedEntry.Wrapper)WeightedRandom.m_216822_(ctx.m_230907_(), resolved).get()).m_146310_();
    } else {
      Player player = findPlayer(ctx);
      if (player == null)
        return; 
      gem = (Gem)GemRegistry.INSTANCE.getRandomItem(ctx.m_230907_(), ctx.m_78945_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches((Level)ctx.m_78952_()), GameStagesCompat.IStaged.matches(player) });
    } 
    RarityClamp clamp = (this.rarityLimit == null) ? (RarityClamp)AdventureConfig.GEM_DIM_RARITIES.get(ctx.m_78952_().m_46472_().m_135782_()) : (RarityClamp)this.rarityLimit;
    ItemStack stack = GemRegistry.createGemStack(gem, gem.clamp(LootRarity.random(ctx.m_230907_(), ctx.m_78945_(), clamp)));
    list.accept(stack);
  }
  
  public LootPoolEntryType m_6751_() {
    return TYPE;
  }
  
  private Gem unwrap(DynamicHolder<Gem> holder) {
    if (!holder.isBound()) {
      AdventureModule.LOGGER.error("A GemLootPoolEntry failed to resolve the Gem {}!", holder.getId());
      return null;
    } 
    return (Gem)holder.get();
  }
  
  @Nullable
  public static Player findPlayer(LootContext ctx) {
    Object object = ctx.m_78953_(LootContextParams.f_81455_);
    if (object instanceof Player)
      return (Player)object; 
    object = ctx.m_78953_(LootContextParams.f_81459_);
    if (object instanceof Player)
      return (Player)object; 
    object = ctx.m_78953_(LootContextParams.f_81458_);
    if (object instanceof Player)
      return (Player)object; 
    if (ctx.m_78953_(LootContextParams.f_81456_) != null)
      return (Player)ctx.m_78953_(LootContextParams.f_81456_); 
    return null;
  }
}
